# Image Transformations

***This page describes how to build image transformations for test time deployment of your exported models.***

To maintain the expected performance of your model after exporting, it is vital that some image transformations used for validation be used again when deploying to the test environment. These transformations are serialized as a JSON file when you export your model.

```json
{
  "__version__" "0.5.1",
  "transform": {
    "__class_fullname__": "albumenations.core.composition.Compose",
    "p": 1,
    "transforms": [
      {
        "__class_fullname__": "albumenations.augmentations.transforms.Resize",
        "always_apply": false,
        "p": 1,
        "height": 224,
        "width": 224,
        "interpolation": 1
      }
    ],
    "bbox_params": null,
    "keypoint_params": null,
    "additional_targets": {}
  }
}
```

Here we can see the "Resize" transformation was used, with the "height" and "width" parameters set to 224.

### Using These Transformations <a href="#using-these-transformations" id="using-these-transformations"></a>

All of the transformations you will see in the `transforms.json` file can be used from the very nice "[albumentations](https://github.com/albumentations-team/albumentations)" library. The transformations can simply be loaded using the albumentations library. To reproduce the transform from the example above, it may look like:

```python
from PIL import Image
import albumentations as A
import numpy as np

transforms = A.load('transforms.json')
image = np.array(Image.open('/some/image/file/path'))
image = transforms(image=image)['image']

# Now the image is preprocessed and ready to be accepted by the model
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.cloudfactory.com/model-playground/image-transformations.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
